var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { Storage } from '@ionic/storage';
import * as i0 from "@angular/core";
import * as i1 from "@ionic/storage";
var Ohm2Db = /** @class */ (function () {
    function Ohm2Db(storage) {
        this.storage = storage;
        this.initialized = false;
        this.baseErrorCode = 182400;
        this.errors = {};
    }
    Ohm2Db.prototype.init = function () {
        var _this = this;
        return new Observable(function (observer) {
            _this.storage.ready()
                .then(function () {
                _this.initialized = true;
                observer.next(true);
                observer.complete();
            })
                .catch(function (err) {
                observer.error(err);
            });
        });
    };
    Ohm2Db.prototype.getValue = function (key) {
        var _this = this;
        return new Observable(function (observer) {
            _this.storage.get(key)
                .then(function (value) {
                observer.next(value);
                observer.complete();
            })
                .catch(function (err) {
                observer.error(err);
            });
        });
    };
    Ohm2Db.prototype.getValueOrDefault = function (key, defaultValue) {
        var _this = this;
        return new Observable(function (observer) {
            _this.getValue(key)
                .subscribe(function (value) {
                if (value) {
                    observer.next(value);
                }
                else {
                    observer.next({ key: key, value: defaultValue });
                }
                observer.complete();
            }, function (err) {
                observer.error(err);
            });
        });
    };
    Ohm2Db.prototype.getKeyAndValue = function (key) {
        var _this = this;
        return new Observable(function (observer) {
            _this.getValue(key)
                .subscribe(function (value) {
                observer.next({ key: key, value: value });
                observer.complete();
            }, function (err) {
                observer.error(err);
            });
        });
    };
    Ohm2Db.prototype.getKeyAndValueOrDefault = function (key, defaultValue) {
        var _this = this;
        return new Observable(function (observer) {
            _this.getValue(key)
                .subscribe(function (value) {
                if (value) {
                    observer.next({ key: key, value: value });
                    observer.complete();
                }
                else {
                    observer.error({ key: key, value: defaultValue });
                }
            }, function (err) {
                observer.error(err);
            });
        });
    };
    Ohm2Db.prototype.setValue = function (key, value) {
        var _this = this;
        return new Observable(function (observer) {
            _this.storage.set(key, value)
                .then(function () {
                observer.next(value);
                observer.complete();
            });
        });
    };
    Ohm2Db.ngInjectableDef = i0.defineInjectable({ factory: function Ohm2Db_Factory() { return new Ohm2Db(i0.inject(i1.Storage)); }, token: Ohm2Db, providedIn: "root" });
    Ohm2Db = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [Storage])
    ], Ohm2Db);
    return Ohm2Db;
}());
export { Ohm2Db };
//# sourceMappingURL=ionic-ohm2-db.service.js.map